// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package circuits

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewCircuitsChoicesReadParams creates a new CircuitsChoicesReadParams object
// with the default values initialized.
func NewCircuitsChoicesReadParams() *CircuitsChoicesReadParams {
	var ()
	return &CircuitsChoicesReadParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewCircuitsChoicesReadParamsWithTimeout creates a new CircuitsChoicesReadParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewCircuitsChoicesReadParamsWithTimeout(timeout time.Duration) *CircuitsChoicesReadParams {
	var ()
	return &CircuitsChoicesReadParams{

		timeout: timeout,
	}
}

// NewCircuitsChoicesReadParamsWithContext creates a new CircuitsChoicesReadParams object
// with the default values initialized, and the ability to set a context for a request
func NewCircuitsChoicesReadParamsWithContext(ctx context.Context) *CircuitsChoicesReadParams {
	var ()
	return &CircuitsChoicesReadParams{

		Context: ctx,
	}
}

// NewCircuitsChoicesReadParamsWithHTTPClient creates a new CircuitsChoicesReadParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewCircuitsChoicesReadParamsWithHTTPClient(client *http.Client) *CircuitsChoicesReadParams {
	var ()
	return &CircuitsChoicesReadParams{
		HTTPClient: client,
	}
}

/*CircuitsChoicesReadParams contains all the parameters to send to the API endpoint
for the circuits choices read operation typically these are written to a http.Request
*/
type CircuitsChoicesReadParams struct {

	/*ID*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the circuits choices read params
func (o *CircuitsChoicesReadParams) WithTimeout(timeout time.Duration) *CircuitsChoicesReadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the circuits choices read params
func (o *CircuitsChoicesReadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the circuits choices read params
func (o *CircuitsChoicesReadParams) WithContext(ctx context.Context) *CircuitsChoicesReadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the circuits choices read params
func (o *CircuitsChoicesReadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the circuits choices read params
func (o *CircuitsChoicesReadParams) WithHTTPClient(client *http.Client) *CircuitsChoicesReadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the circuits choices read params
func (o *CircuitsChoicesReadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the circuits choices read params
func (o *CircuitsChoicesReadParams) WithID(id string) *CircuitsChoicesReadParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the circuits choices read params
func (o *CircuitsChoicesReadParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *CircuitsChoicesReadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
