// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDcimVirtualChassisListParams creates a new DcimVirtualChassisListParams object
// with the default values initialized.
func NewDcimVirtualChassisListParams() *DcimVirtualChassisListParams {
	var ()
	return &DcimVirtualChassisListParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewDcimVirtualChassisListParamsWithTimeout creates a new DcimVirtualChassisListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDcimVirtualChassisListParamsWithTimeout(timeout time.Duration) *DcimVirtualChassisListParams {
	var ()
	return &DcimVirtualChassisListParams{

		timeout: timeout,
	}
}

// NewDcimVirtualChassisListParamsWithContext creates a new DcimVirtualChassisListParams object
// with the default values initialized, and the ability to set a context for a request
func NewDcimVirtualChassisListParamsWithContext(ctx context.Context) *DcimVirtualChassisListParams {
	var ()
	return &DcimVirtualChassisListParams{

		Context: ctx,
	}
}

// NewDcimVirtualChassisListParamsWithHTTPClient creates a new DcimVirtualChassisListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDcimVirtualChassisListParamsWithHTTPClient(client *http.Client) *DcimVirtualChassisListParams {
	var ()
	return &DcimVirtualChassisListParams{
		HTTPClient: client,
	}
}

/*DcimVirtualChassisListParams contains all the parameters to send to the API endpoint
for the dcim virtual chassis list operation typically these are written to a http.Request
*/
type DcimVirtualChassisListParams struct {

	/*Limit
	  Number of results to return per page.

	*/
	Limit *int64
	/*Offset
	  The initial index from which to return the results.

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) WithTimeout(timeout time.Duration) *DcimVirtualChassisListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) WithContext(ctx context.Context) *DcimVirtualChassisListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) WithHTTPClient(client *http.Client) *DcimVirtualChassisListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) WithLimit(limit *int64) *DcimVirtualChassisListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) WithOffset(offset *int64) *DcimVirtualChassisListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim virtual chassis list params
func (o *DcimVirtualChassisListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *DcimVirtualChassisListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
