// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package extras

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewExtrasRecentActivityListParams creates a new ExtrasRecentActivityListParams object
// with the default values initialized.
func NewExtrasRecentActivityListParams() *ExtrasRecentActivityListParams {
	var ()
	return &ExtrasRecentActivityListParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewExtrasRecentActivityListParamsWithTimeout creates a new ExtrasRecentActivityListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewExtrasRecentActivityListParamsWithTimeout(timeout time.Duration) *ExtrasRecentActivityListParams {
	var ()
	return &ExtrasRecentActivityListParams{

		timeout: timeout,
	}
}

// NewExtrasRecentActivityListParamsWithContext creates a new ExtrasRecentActivityListParams object
// with the default values initialized, and the ability to set a context for a request
func NewExtrasRecentActivityListParamsWithContext(ctx context.Context) *ExtrasRecentActivityListParams {
	var ()
	return &ExtrasRecentActivityListParams{

		Context: ctx,
	}
}

// NewExtrasRecentActivityListParamsWithHTTPClient creates a new ExtrasRecentActivityListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewExtrasRecentActivityListParamsWithHTTPClient(client *http.Client) *ExtrasRecentActivityListParams {
	var ()
	return &ExtrasRecentActivityListParams{
		HTTPClient: client,
	}
}

/*ExtrasRecentActivityListParams contains all the parameters to send to the API endpoint
for the extras recent activity list operation typically these are written to a http.Request
*/
type ExtrasRecentActivityListParams struct {

	/*Limit
	  Number of results to return per page.

	*/
	Limit *int64
	/*Offset
	  The initial index from which to return the results.

	*/
	Offset *int64
	/*User*/
	User *string
	/*Username*/
	Username *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithTimeout(timeout time.Duration) *ExtrasRecentActivityListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithContext(ctx context.Context) *ExtrasRecentActivityListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithHTTPClient(client *http.Client) *ExtrasRecentActivityListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithLimit(limit *int64) *ExtrasRecentActivityListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithOffset(offset *int64) *ExtrasRecentActivityListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithUser adds the user to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithUser(user *string) *ExtrasRecentActivityListParams {
	o.SetUser(user)
	return o
}

// SetUser adds the user to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetUser(user *string) {
	o.User = user
}

// WithUsername adds the username to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) WithUsername(username *string) *ExtrasRecentActivityListParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the extras recent activity list params
func (o *ExtrasRecentActivityListParams) SetUsername(username *string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *ExtrasRecentActivityListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.User != nil {

		// query param user
		var qrUser string
		if o.User != nil {
			qrUser = *o.User
		}
		qUser := qrUser
		if qUser != "" {
			if err := r.SetQueryParam("user", qUser); err != nil {
				return err
			}
		}

	}

	if o.Username != nil {

		// query param username
		var qrUsername string
		if o.Username != nil {
			qrUsername = *o.Username
		}
		qUsername := qrUsername
		if qUsername != "" {
			if err := r.SetQueryParam("username", qUsername); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
