// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewIPAMChoicesReadParams creates a new IPAMChoicesReadParams object
// with the default values initialized.
func NewIPAMChoicesReadParams() *IPAMChoicesReadParams {
	var ()
	return &IPAMChoicesReadParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewIPAMChoicesReadParamsWithTimeout creates a new IPAMChoicesReadParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewIPAMChoicesReadParamsWithTimeout(timeout time.Duration) *IPAMChoicesReadParams {
	var ()
	return &IPAMChoicesReadParams{

		timeout: timeout,
	}
}

// NewIPAMChoicesReadParamsWithContext creates a new IPAMChoicesReadParams object
// with the default values initialized, and the ability to set a context for a request
func NewIPAMChoicesReadParamsWithContext(ctx context.Context) *IPAMChoicesReadParams {
	var ()
	return &IPAMChoicesReadParams{

		Context: ctx,
	}
}

// NewIPAMChoicesReadParamsWithHTTPClient creates a new IPAMChoicesReadParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewIPAMChoicesReadParamsWithHTTPClient(client *http.Client) *IPAMChoicesReadParams {
	var ()
	return &IPAMChoicesReadParams{
		HTTPClient: client,
	}
}

/*IPAMChoicesReadParams contains all the parameters to send to the API endpoint
for the ipam choices read operation typically these are written to a http.Request
*/
type IPAMChoicesReadParams struct {

	/*ID*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the ipam choices read params
func (o *IPAMChoicesReadParams) WithTimeout(timeout time.Duration) *IPAMChoicesReadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam choices read params
func (o *IPAMChoicesReadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam choices read params
func (o *IPAMChoicesReadParams) WithContext(ctx context.Context) *IPAMChoicesReadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam choices read params
func (o *IPAMChoicesReadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam choices read params
func (o *IPAMChoicesReadParams) WithHTTPClient(client *http.Client) *IPAMChoicesReadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam choices read params
func (o *IPAMChoicesReadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the ipam choices read params
func (o *IPAMChoicesReadParams) WithID(id string) *IPAMChoicesReadParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ipam choices read params
func (o *IPAMChoicesReadParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *IPAMChoicesReadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
