// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package virtualization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewVirtualizationChoicesReadParams creates a new VirtualizationChoicesReadParams object
// with the default values initialized.
func NewVirtualizationChoicesReadParams() *VirtualizationChoicesReadParams {
	var ()
	return &VirtualizationChoicesReadParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewVirtualizationChoicesReadParamsWithTimeout creates a new VirtualizationChoicesReadParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewVirtualizationChoicesReadParamsWithTimeout(timeout time.Duration) *VirtualizationChoicesReadParams {
	var ()
	return &VirtualizationChoicesReadParams{

		timeout: timeout,
	}
}

// NewVirtualizationChoicesReadParamsWithContext creates a new VirtualizationChoicesReadParams object
// with the default values initialized, and the ability to set a context for a request
func NewVirtualizationChoicesReadParamsWithContext(ctx context.Context) *VirtualizationChoicesReadParams {
	var ()
	return &VirtualizationChoicesReadParams{

		Context: ctx,
	}
}

// NewVirtualizationChoicesReadParamsWithHTTPClient creates a new VirtualizationChoicesReadParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewVirtualizationChoicesReadParamsWithHTTPClient(client *http.Client) *VirtualizationChoicesReadParams {
	var ()
	return &VirtualizationChoicesReadParams{
		HTTPClient: client,
	}
}

/*VirtualizationChoicesReadParams contains all the parameters to send to the API endpoint
for the virtualization choices read operation typically these are written to a http.Request
*/
type VirtualizationChoicesReadParams struct {

	/*ID*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) WithTimeout(timeout time.Duration) *VirtualizationChoicesReadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) WithContext(ctx context.Context) *VirtualizationChoicesReadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) WithHTTPClient(client *http.Client) *VirtualizationChoicesReadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) WithID(id string) *VirtualizationChoicesReadParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the virtualization choices read params
func (o *VirtualizationChoicesReadParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *VirtualizationChoicesReadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
